/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2206 from the
 * contents of Preproc.xs. Do not edit this file, edit Preproc.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Preproc.xs"
#/* Verilog.xs -- Verilog Booter  -*- C++ -*-
#*********************************************************************
#*
#* DESCRIPTION: Verilog::Preproc Perl XS interface
#*
#* Author: Wilson Snyder <wsnyder@wsnyder.org>
#*
#* Code available from: http://www.veripool.org/
#*
#*********************************************************************
#*
#* Copyright 2000-2009 by Wilson Snyder.  This program is free software;
#* you can redistribute it and/or modify it under the terms of either the GNU
#* Lesser General Public License Version 3 or the Perl Artistic License Version 2.0.
#*
#* This program is distributed in the hope that it will be useful,
#* but WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU General Public License for more details.
#*
#* You should have received a copy of the Perl Artistic License
#* along with this module; see the file COPYING.  If not, see
#* www.cpan.org
#*
#***********************************************************************
#* Note with C++ XS libraries, the CLASS parameter is implied...
#***********************************************************************/

/* Mine: */
#include "VPreproc.h"

/* Perl */
extern "C" {
# include "EXTERN.h"
# include "perl.h"
# include "XSUB.h"
}

#ifdef open
# undef open	/* Perl 64 bit on solaris has a nasty hack that redefines open */
#endif

#//**********************************************************************
#// Preprocessor derived classes, so we can override the callbacks to call perl.

class VPreprocXs : public VPreproc {
public:
    SV*		m_self;	// Class called from
    int		m_keepComments;
    int		m_keepWhitespace;
    bool	m_lineDirectives;
    bool	m_pedantic;

    VPreprocXs(VFileLine* filelinep) : VPreproc(filelinep) {}
    virtual ~VPreprocXs() {}

    // Control methods
    virtual int  keepComments() { return m_keepComments; }	// Return comments
    virtual int  keepWhitespace() { return m_keepWhitespace; }	// Return extra whitespace
    virtual bool lineDirectives() { return m_lineDirectives; }	// Insert `line directives
    virtual bool pedantic() { return m_pedantic; }		// Obey standard; Don't substitute `__FILE__ and `__LINE__

    // Callback methods
    virtual void comment(string filename);	// Comment for keepComments=>sub
    virtual void include(string filename);	// Request a include file be processed
    virtual void define(string name, string value, string params); // `define with parameters
    virtual void undef(string name);		// Remove a definition
    virtual string defParams(string name);	// Return parameter list if define exists
    virtual string defValue(string name);	// Return value of given define (should exist)
    virtual string defSubstitute(string substitute);	///< Return value to substitute for given post-parameter value

    void call(string* rtnStrp, int params, const char* method, ...);
    void unreadback(char* text);
};

class VFileLineXs : public VFileLine {
    VPreprocXs*	m_vPreprocp;		// Parser handling the errors
public:
    VFileLineXs(int called_only_for_default) : VFileLine(called_only_for_default) {}
    virtual ~VFileLineXs() { }
    virtual VFileLine* create(const string filename, int lineno);
    virtual void error(const string msg);	// Report a error at given location
    void setPreproc(VPreprocXs* pp) { m_vPreprocp=pp; }
};

#//**********************************************************************
#// Overrides error handling virtual functions to invoke callbacks

VFileLine* VFileLineXs::create(const string filename, int lineno) {
    VFileLineXs* filelp = new VFileLineXs(true);
    filelp->init(filename, lineno);
    filelp->m_vPreprocp = m_vPreprocp;
    return filelp;
}

void VFileLineXs::error(string msg) {
    static string holdmsg; holdmsg = msg;
    m_vPreprocp->call(NULL, 1,"error",holdmsg.c_str());
}

#//**********************************************************************
#// Overrides of virtual functions to invoke callbacks

void VPreprocXs::comment(string cmt) {
    static string holdcmt; holdcmt = cmt;
    call(NULL, 1,"comment",holdcmt.c_str());
}
void VPreprocXs::include(string filename) {
    static string holdfilename; holdfilename = filename;
    call(NULL, 1,"include",holdfilename.c_str());
}
void VPreprocXs::undef(string define) {
    static string holddefine; holddefine = define;
    call(NULL, 1,"undef", holddefine.c_str());
}
void VPreprocXs::define(string define, string value, string params) {
    static string holddefine; holddefine = define;
    static string holdvalue; holdvalue = value;
    static string holdparams; holdparams = params;
    call(NULL, 3,"define", holddefine.c_str(), holdvalue.c_str(), holdparams.c_str());
}
string VPreprocXs::defParams(string define) {
    static string holddefine; holddefine = define;
    string paramStr;
    call(&paramStr, 1,"def_params", holddefine.c_str());
    return paramStr;
}
string VPreprocXs::defValue(string define) {
    static string holddefine; holddefine = define;
    string valueStr;
    call(&valueStr, 1,"def_value", holddefine.c_str());
    return valueStr;
}
string VPreprocXs::defSubstitute(string subs) {
    static string holdsubs; holdsubs = subs;
    string outStr;
    call(&outStr, 1, "def_substitute", holdsubs.c_str());
    return outStr;
}

void VPreprocXs::call (
    string* rtnStrp,	/* If non-null, load return value here */
    int params,		/* Number of parameters.  Negative frees the parameters */
    const char* method,	/* Name of method to call */
    ...)		/* Arguments to pass to method's @_ */
{
    // Call $perlself->method (passedparam1, parsedparam2)
    va_list ap;
    va_start(ap, method);
    {
	dSP;				/* Initialize stack pointer */
	ENTER;				/* everything created after here */
	SAVETMPS;			/* ...is a temporary variable. */
	PUSHMARK(SP);			/* remember the stack pointer */
	XPUSHs(m_self);			/* $self-> */

	while (params--) {
	    char *text;
	    SV *sv;
	    text = va_arg(ap, char *);
	    sv = newSVpv (text, 0);
	    XPUSHs(sv);			/* token */
	}

	PUTBACK;			/* make local stack pointer global */

	if (rtnStrp) {
	    int rtnCount = perl_call_method ((char*)method, G_SCALAR);
	    SPAGAIN;			/* refresh stack pointer */
	    if (rtnCount > 0) {
		SV* sv = POPs;
		//printf("RTN %ld %d %s\n", SvTYPE(sv),SvTRUE(sv),SvPV_nolen(sv));
#ifdef SvPV_nolen	// Perl 5.6 and later
		*rtnStrp = SvPV_nolen(sv);
#else
		*rtnStrp = SvPV(sv,PL_na);
#endif
	    }
	    PUTBACK;
	} else {
	    perl_call_method ((char*)method, G_DISCARD | G_VOID);
	}

	FREETMPS;			/* free that return value */
	LEAVE;				/* ...and the XPUSHed "mortal" args.*/
    }
    va_end(ap);
}

#//**********************************************************************

#line 202 "Preproc.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 254 "Preproc.c"

XS(XS_Verilog__Preproc__new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Preproc__new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "CLASS, SELF, keepcmt, keepwhite, linedir, pedantic");
    {
	SV *	SELF = ST(1);
	int	keepcmt = (int)SvIV(ST(2));
	int	keepwhite = (int)SvIV(ST(3));
	int	linedir = (int)SvIV(ST(4));
	int	pedantic = (int)SvIV(ST(5));
	char *	CLASS = (char *)SvPV_nolen(ST(0));
	VPreprocXs *	RETVAL;
#line 206 "Preproc.xs"
{
    if (CLASS) {}  /* Prevent unused warning */
    VFileLineXs* filelinep = new VFileLineXs(1/*ok,for initial*/);
    VPreprocXs* preprocp = new VPreprocXs(filelinep);
    filelinep->setPreproc(preprocp);
    preprocp->m_self = newSVsv(SELF);
    preprocp->m_keepComments = keepcmt;
    preprocp->m_keepWhitespace = keepwhite;
    preprocp->m_lineDirectives = linedir;
    preprocp->m_pedantic = pedantic;
    RETVAL = preprocp;
}
#line 287 "Preproc.c"
	ST(0) = sv_newmortal();
    // SELF->{_cthis} = THIS
    if( sv_isobject(SELF) && (SvTYPE(SvRV(SELF)) == SVt_PVHV) ) {
	SV **svp = hv_fetch ((HV*)SvRV(SELF), "_cthis", 6, 1);
	sv_setiv(*svp, PTR2IV( RETVAL ));
	XSRETURN_UNDEF;
    } else {
        warn( "Verilog::Preproc::_new() -- RETVAL is not a Verilog::Preproc object" );
        XSRETURN_UNDEF;
    }

    }
    XSRETURN(1);
}


XS(XS_Verilog__Preproc__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Preproc__DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	VPreprocXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VPreprocXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VPreprocXs*>(THIS)) {
        warn( "Verilog::Preproc::_DESTROY() -- THIS is not a Verilog::Preproc object" );
        XSRETURN_UNDEF;
    };
#line 227 "Preproc.xs"
{
    delete THIS;
}
#line 329 "Preproc.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Verilog__Preproc__debug); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Preproc__debug)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "THIS, level");
    {
	int	level = (int)SvIV(ST(1));
	VPreprocXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VPreprocXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VPreprocXs*>(THIS)) {
        warn( "Verilog::Preproc::_debug() -- THIS is not a Verilog::Preproc object" );
        XSRETURN_UNDEF;
    };
#line 238 "Preproc.xs"
{
    THIS->debug(level);
}
#line 361 "Preproc.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Verilog__Preproc_lineno); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Preproc_lineno)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	VPreprocXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VPreprocXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VPreprocXs*>(THIS)) {
        warn( "Verilog::Preproc::lineno() -- THIS is not a Verilog::Preproc object" );
        XSRETURN_UNDEF;
    };
	int	RETVAL;
	dXSTARG;
#line 249 "Preproc.xs"
{
    if (!THIS) XSRETURN_UNDEF;
    RETVAL = (THIS->filelinep()->lineno());
}
#line 395 "Preproc.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Verilog__Preproc_filename); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Preproc_filename)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	VPreprocXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VPreprocXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VPreprocXs*>(THIS)) {
        warn( "Verilog::Preproc::filename() -- THIS is not a Verilog::Preproc object" );
        XSRETURN_UNDEF;
    };
	const char *	RETVAL;
	dXSTARG;
#line 262 "Preproc.xs"
{
    if (!THIS) XSRETURN_UNDEF;
    RETVAL = THIS->filelinep()->filename().c_str();
}
#line 430 "Preproc.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Verilog__Preproc_unreadback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Preproc_unreadback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "THIS, text");
    {
	char*	text = (char *)SvPV_nolen(ST(1));
	VPreprocXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VPreprocXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VPreprocXs*>(THIS)) {
        warn( "Verilog::Preproc::unreadback() -- THIS is not a Verilog::Preproc object" );
        XSRETURN_UNDEF;
    };
#line 276 "Preproc.xs"
{
    if (!THIS) XSRETURN_UNDEF;
    THIS->insertUnreadback((string)text);
}
#line 464 "Preproc.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Verilog__Preproc_getline); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Preproc_getline)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	VPreprocXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VPreprocXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VPreprocXs*>(THIS)) {
        warn( "Verilog::Preproc::getline() -- THIS is not a Verilog::Preproc object" );
        XSRETURN_UNDEF;
    };
	const char *	RETVAL;
	dXSTARG;
#line 288 "Preproc.xs"
{
    static string holdline;
    if (!THIS || THIS->isEof()) XSRETURN_UNDEF;
    string lastline = THIS->getline();
    holdline = lastline;	/* Stash it so c_str() doesn't disappear immediately */
    RETVAL = lastline.c_str();
}
#line 501 "Preproc.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Verilog__Preproc_eof); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Preproc_eof)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	VPreprocXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VPreprocXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VPreprocXs*>(THIS)) {
        warn( "Verilog::Preproc::eof() -- THIS is not a Verilog::Preproc object" );
        XSRETURN_UNDEF;
    };
	int	RETVAL;
	dXSTARG;
#line 304 "Preproc.xs"
{
    RETVAL = THIS->isEof();
}
#line 535 "Preproc.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Verilog__Preproc__open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Verilog__Preproc__open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "THIS, filename");
    {
	const char *	filename = (const char *)SvPV_nolen(ST(1));
	VPreprocXs *    THIS = NULL;
    if( sv_isobject(ST(0)) && (SvTYPE(SvRV( ST(0) )) == SVt_PVHV) ) {
        SV **svp = hv_fetch ((HV*)SvRV(( ST(0) )), "_cthis", 6, 0);
	THIS = NULL;
	if (svp) { THIS = INT2PTR(VPreprocXs *,SvIV( *svp )); }
    }
    if (!THIS || !dynamic_cast<VPreprocXs*>(THIS)) {
        warn( "Verilog::Preproc::_open() -- THIS is not a Verilog::Preproc object" );
        XSRETURN_UNDEF;
    };
	int	RETVAL;
	dXSTARG;
#line 317 "Preproc.xs"
{
    if (!THIS) XSRETURN_UNDEF;
    THIS->open(filename);
    RETVAL = 1;
}
#line 572 "Preproc.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Verilog__Preproc); /* prototype to pass -Wmissing-prototypes */
XS(boot_Verilog__Preproc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        (void)newXSproto_portable("Verilog::Preproc::_new", XS_Verilog__Preproc__new, file, "$$$$$");
        (void)newXSproto_portable("Verilog::Preproc::_DESTROY", XS_Verilog__Preproc__DESTROY, file, "$");
        (void)newXSproto_portable("Verilog::Preproc::_debug", XS_Verilog__Preproc__debug, file, "$$");
        (void)newXSproto_portable("Verilog::Preproc::lineno", XS_Verilog__Preproc_lineno, file, "$");
        (void)newXSproto_portable("Verilog::Preproc::filename", XS_Verilog__Preproc_filename, file, "$");
        (void)newXSproto_portable("Verilog::Preproc::unreadback", XS_Verilog__Preproc_unreadback, file, "$$");
        (void)newXSproto_portable("Verilog::Preproc::getline", XS_Verilog__Preproc_getline, file, "$");
        (void)newXSproto_portable("Verilog::Preproc::eof", XS_Verilog__Preproc_eof, file, "$");
        (void)newXSproto_portable("Verilog::Preproc::_open", XS_Verilog__Preproc__open, file, "$$");
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

